/* cmdline.h */

/* File autogenerated by gengetopt version 2.10  */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "teebu"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION VERSION
#endif

struct gengetopt_args_info
{
  char * file_arg;	/* filename of the archive.  */
  char * label_arg;	/* set archive label.  */
  char * target_arg;	/* set the target directory for extraction and verification (default='.').  */
  int input_filelist_flag;	/* read file list from stdin (default=off).  */
  long chunk_arg;	/* chunk data into the given size (default='33554432').  */
  int tape_blocks_arg;	/* write data in blocks of the given size.  */
  char * gpg_arg;	/* encrypt using gpg with the specified key file.  */
  int show_progress_flag;	/* display progress statistics (implies --show-final) (default=off).  */
  int show_final_flag;	/* display final statistics (default=off).  */
  int md5_flag;	/* write or verify MD5 checksums (default=off).  */
  int sha1_flag;	/* write or verify SHA1 checksums (default=off).  */
  int ignore_header_flag;	/* ignore archive header (you will need to supply compression and encryption) (default=off).  */
  char ** simulate_error_arg;	/* simulate an error on input (for testing).  */
  int hide_info_flag;	/* if encryption is enabled, encrypt the archive label and timestamp as well (default=off).  */
  int hide_id_flag;	/* if encryption is enabled, encrypt the archive uid as well (default=off).  */
  char * compress_arg;	/* compress using given program.  */

  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int file_given ;	/* Whether file was given.  */
  int label_given ;	/* Whether label was given.  */
  int target_given ;	/* Whether target was given.  */
  int input_filelist_given ;	/* Whether input-filelist was given.  */
  int chunk_given ;	/* Whether chunk was given.  */
  int tape_blocks_given ;	/* Whether tape-blocks was given.  */
  int gpg_given ;	/* Whether gpg was given.  */
  int show_progress_given ;	/* Whether show-progress was given.  */
  int show_final_given ;	/* Whether show-final was given.  */
  int md5_given ;	/* Whether md5 was given.  */
  int sha1_given ;	/* Whether sha1 was given.  */
  int ignore_header_given ;	/* Whether ignore-header was given.  */
  int simulate_error_given ;	/* Whether simulate-error was given.  */
  int hide_info_given ;	/* Whether hide-info was given.  */
  int hide_id_given ;	/* Whether hide-id was given.  */
  int silent_given ;	/* Whether silent was given.  */
  int quiet_given ;	/* Whether quiet was given.  */
  int verbose_given ;	/* Whether verbose was given.  */
  int debug_given ;	/* Whether debug was given.  */
  int gzip_given ;	/* Whether gzip was given.  */
  int bzip2_given ;	/* Whether bzip2 was given.  */
  int compress_given ;	/* Whether compress was given.  */
  int create_given ;	/* Whether create was given.  */
  int test_given ;	/* Whether test was given.  */
  int verify_given ;	/* Whether verify was given.  */
  int extract_given ;	/* Whether extract was given.  */
  int identify_given ;	/* Whether identify was given.  */
  int selftest_given ;	/* Whether selftest was given.  */

  char **inputs ; /* unamed options */
  unsigned inputs_num ; /* unamed options number */
} ;

int cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
