/* $Id: gzipio.c 658 2006-05-13 14:50:30Z jim $
   teebu - An archiving tool
   Copyright (C) 2006 Jim Farrand

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
   more details.

   You should have received a copy of the GNU General Public License along with
   this program; if not, write to the Free Software Foundation, Inc., 51
   Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */


#include <stdio.h>

#include "gzipio.h"

#include "commandfilterio.h"

out_stream_t
gzipio_open_out (int level, out_stream_t base_outs, bool own_base)
{
  if (level < 1 || level > 9)
    return NULL;

  char compression[4];
  snprintf (compression, 4, "-%d", level);

  char *argv[] = {
    "/bin/gzip",
    compression,
    NULL
  };

  return commandfilter_open_out ("/bin/gzip", 4096, argv, NULL, NULL, NULL,
                                 base_outs, own_base);
}

in_stream_t
gzipio_open_in (in_stream_t base_ins, bool own_base)
{
  char *argv[] = {
    "/bin/gunzip",
    NULL
  };

  return commandfilter_open_in ("/bin/gunzip", 4096, argv, NULL, NULL, NULL,
                                base_ins, own_base);
}
